Orthographic (OpenMap API)
Date: 2016-12-09

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bbn.openmap.proj
Class Orthographic

    java.lang.Object
      com.bbn.openmap.proj.Proj
          com.bbn.openmap.proj.GeoProj
              com.bbn.openmap.proj.Azimuth
                  com.bbn.openmap.proj.Orthographic

All Implemented Interfaces:
  Projection, java.io.Serializable, java.lang.Cloneable

    public class Orthographic

extends Azimuth

Implements the Orthographic projection.

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class com.bbn.openmap.proj.Azimuth
`Azimuth.AzimuthVar`

Field Summary
`protected double` | `cosCtrLat`
`static double` | `epsilon`
`protected double` | `hy`
`protected static double` | `NORTH_BOUNDARY`
`static java.lang.String` | `OrthographicName` The Orthographic name.
`protected double` | `sinCtrLat`
`protected static double` | `SOUTH_BOUNDARY`
`protected double` | `wx`

Fields inherited from class com.bbn.openmap.proj.Azimuth
`clockwise, spaceColor, world`

Fields inherited from class com.bbn.openmap.proj.GeoProj
`DATELINE, mercator, NORTH_POLE, NUM_DEFAULT_CIRCLE_VERTS, NUM_DEFAULT_GREAT_SEGS, pixelsPerMeter, planetPixelCircumference, planetPixelRadius, planetRadius, scaled_radius, SOUTH_POLE, XSCALE_THRESHOLD, XTHRESHOLD`

Fields inherited from class com.bbn.openmap.proj.Proj
`centerX, centerY, height, maxscale, MIN_HEIGHT, MIN_WIDTH, minscale, projID, rotationAngle, scale, ucuom, width`

Constructor Summary
`Orthographic(LatLonPoint center, float scale, int width, int height)` Construct an Orthographic projection.

Method Summary
`protected java.awt.geom.Point2D` | `_forward(double phi, double lambda, java.awt.geom.Point2D p, Azimuth.AzimuthVar azVar)` Forward project a point.
`protected void` | `computeParameters()` Called when some fundamental parameters change.
`LatLonPoint` | `getLowerRight()` Get the lower right (southeast) point of the projection.
`java.lang.String` | `getName()` Get the name string of the projection.
`LatLonPoint` | `getUpperLeft()` Get the upper left (northernmost and westernmost) point of the projection.
`static boolean` | `hemisphere_clip(double phi1, double lambda0, double phi, double lambda)`
`static boolean` | `hemisphere_clip(float phi1, float lambda0, float phi, float lambda)` Check if a given lat/lon is within the visible hemisphere.
`
`<T extends java.awt.geom.Point2D> T`
` | `inverse(double x, double y, T llp)` Inverse project x,y coordinates into a LatLonPoint.
`boolean` | `isPlotable(double lat, double lon)` Checks if a LatLonPoint is plot-able.
`double` | `normalizeLatitude(double lat)` Sets radian latitude to something sane.
`java.lang.String` | `toString()` Return stringified description of this projection.

Methods inherited from class com.bbn.openmap.proj.Azimuth
`_forwardPoly, _forwardPoly, _panE, _panN, _panNE, _panNW, _panS, _panSE, _panSW, _panW, drawBackground, forward, forwardRaw, forwardRaw, getSpaceColor, init, isClockwiseTraversal, overNorthPole, overPoint, overSouthPole, pan, setClockwiseTraversal, setSpaceColor`

Methods inherited from class com.bbn.openmap.proj.GeoProj
`assertLatLonPoint, clone, doPolyDispatch, doPolyDispatch, forward, forward, forward, forward, forwardArc, forwardArc, forwardArc, forwardCircle, forwardCircle, forwardCircle, forwardGreatPoly, forwardGreatPoly, forwardLine, forwardLine, forwardLLPoly, forwardPoly, forwardPoly, forwardRect, forwardRect, forwardRect, forwardRhumbPoly, forwardRhumbPoly, getCenter, getCenter, getGCTForProjection, getPlanetPixelCircumference, getPlanetPixelRadius, getPlanetRadius, getPPM, getReferenceLon, getScale, getUcuom, inverse, inverse, isComplicatedLineType, isPlotable, normalize_latitude, normalizeLatitude, pan, pan, setCenter, setCenter, setCenter, setPlanetRadius, setPPM, setUcuom, wrap_longitude, wrapLongitude, wrapLongitude, wrapLongitudeDeg`

Methods inherited from class com.bbn.openmap.proj.Proj
`drawBackground, equals, forward, forward, forward, forwardLine, forwardPoly, forwardPoly, forwardRect, forwardShape, getHeight, getMaxScale, getMinScale, getProjectionID, getRotationAngle, getScale, getWidth, hashCode, inverse, inverseShape, makeClone, panE, panE, panN, panN, panNE, panNE, panNW, panNW, panS, panS, panSE, panSE, panSW, panSW, panW, panW, setCenter, setHeight, setMaxScale, setMinScale, setParms, setProjectionID, setRotationAngle, setScale, setWidth`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### OrthographicName

    public static final transient java.lang.String OrthographicName

  The Orthographic name.

  See Also:
    Constant Field Values

### hy

    protected double hy

### wx

    protected double wx

### cosCtrLat

    protected double cosCtrLat

### sinCtrLat

    protected double sinCtrLat

### epsilon

    public static final transient double epsilon

See Also:
  Constant Field Values

### NORTH_BOUNDARY

    protected static final double NORTH_BOUNDARY

See Also:
  Constant Field Values

### SOUTH_BOUNDARY

    protected static final double SOUTH_BOUNDARY

See Also:
  Constant Field Values

Constructor Detail

### Orthographic

    public Orthographic(LatLonPoint center,
                        float scale,
                        int width,
                        int height)

  Construct an Orthographic projection.

  Parameters:
    `center` - LatLonPoint center of projection
    `scale` - float scale of projection
    `width` - width of screen
    `height` - height of screen

Method Detail

### toString

    public java.lang.String toString()

  Return stringified description of this projection.

  Overrides:
    `toString` in class `Azimuth`
  Returns:
    String
  See Also:
    `Projection.getProjectionID()`

### computeParameters

    protected void computeParameters()

  Called when some fundamental parameters change.

  Each projection will decide how to respond to this change. For instance, they may need to recalculate "constant" parameters used in the forward() and inverse() calls.

  Overrides:
    `computeParameters` in class `Azimuth`

### normalizeLatitude

    public double normalizeLatitude(double lat)

  Sets radian latitude to something sane. This is an abstract function since some projections don't deal well with extreme latitudes.

  Specified by:
    `normalizeLatitude` in class `GeoProj`
  Parameters:
    `lat` - float latitude in radians
  Returns:
    float latitude (-PI/2 <= y <= PI/2)

### hemisphere_clip

    public static final boolean hemisphere_clip(float phi1,
                                                float lambda0,
                                                float phi,
                                                float lambda)

  Check if a given lat/lon is within the visible hemisphere.

  Parameters:
    `phi1` - latitude
    `lambda0` - longitude
    `phi` - latitude
    `lambda` - longitude
  Returns:
    boolean true if within the visible hemisphere, false if not

### hemisphere_clip

    public static final boolean hemisphere_clip(double phi1,
                                                double lambda0,
                                                double phi,
                                                double lambda)

### isPlotable

    public boolean isPlotable(double lat,
                              double lon)

  Checks if a LatLonPoint is plot-able.

  A point is plot-able if it is within the visible hemisphere.

  Specified by:
    `isPlotable` in interface `Projection`
  Overrides:
    `isPlotable` in class `Proj`
  Parameters:
    `lat` - float latitude in decimal degrees
    `lon` - float longitude in decimal degrees
  Returns:
    boolean

### _forward

    protected java.awt.geom.Point2D _forward(double phi,
                                             double lambda,
                                             java.awt.geom.Point2D p,
                                             Azimuth.AzimuthVar azVar)

  Forward project a point. If the point is not within the viewable hemisphere, return flags in AzimuthVar variable if specified.

  Specified by:
    `_forward` in class `Azimuth`
  Parameters:
    `phi` - double latitude in radians
    `lambda` - double longitude in radians
    `p` - Point2D
    `azVar` - AzimuthVar or null
  Returns:
    Point2D pt

### inverse

    public <T extends java.awt.geom.Point2D> T inverse(double x,
                                                       double y,
                                                       T llp)

  Inverse project x,y coordinates into a LatLonPoint.

  Specified by:
    `inverse` in interface `Projection`
  Specified by:
    `inverse` in class `Proj`
  Parameters:
    `x` - integer x coordinate
    `y` - integer y coordinate
    `llp` - LatLonPoint
  Returns:
    LatLonPoint llp
  See Also:
    `Proj.inverse(Point2D)`

### getUpperLeft

    public LatLonPoint getUpperLeft()

  Get the upper left (northernmost and westernmost) point of the projection.

  Returns the upper left point (or closest equivalent) of the projection based on the center point and height and width of screen.

  Specified by:
    `getUpperLeft` in interface `Projection`
  Overrides:
    `getUpperLeft` in class `Proj`
  Returns:
    LatLonPoint

### getLowerRight

    public LatLonPoint getLowerRight()

  Get the lower right (southeast) point of the projection.

  Returns the lower right point (or closest equivalent) of the projection based on the center point and height and width of screen.

  This is trivial for most cylindrical projections, but much more complicated for azimuthal projections.

  Specified by:
    `getLowerRight` in interface `Projection`
  Overrides:
    `getLowerRight` in class `Proj`
  Returns:
    LatLonPoint

### getName

    public java.lang.String getName()

  Get the name string of the projection.

  Specified by:
    `getName` in interface `Projection`
  Overrides:
    `getName` in class `Azimuth`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) BBNT Solutions LLC; See http://openmap.bbn.com/ for details